-- functions.lua
-- Written By Habna


-- **v Hide HugeBag v**
function ShowHugeBag()
	if ( frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		frmMain:SetVisible( true );
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		frmMain:SetVisible( false );
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Show Help Info v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( "HugeBag" );
end
-- **^
-- **v Show Help Info v**
function ReloadHugeBag()
	--UnloadHugeBag();
	--LoadHugeBag();
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	HideWEsc = ( not HideWEsc );
	SaveSettings();
	if ( HideWEsc ) then
		write( "HugeBag: I will hide when 'esc' key is press" );
	else
		write( "HugeBag: I will stay visible when 'esc' key is press" );
	end
end
-- **^
-- **v Toggle Startup Visibility v**
function ToggleShow()
	StartVisible = ( not StartVisible );
	SaveSettings();
	if ( StartVisible ) then
		write( "HugeBag: I will load visibile next time" );
	else
		write( "HugeBag: I will load hidden next time" );
	end
end
-- **^
-- **v Toggle to use widget mode are not v**
function ToggleWidgetMode()
	Widget = ( not Widget );
	SaveSettings();
	if ( Widget ) then
		write( "HugeBag: Will load in widget mode next time" );
	else
		write( "HugeBag: Will load in window mode next time" );
	end
end
-- **^
-- **v Show About window v**
function ShowAbout()
	import "HabnaPlugins.HugeBag.About"; -- LUA frmAbout file
	frmAbout();
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.background"; -- LUA frmOptions file
	frmBackground();
end
-- **^
-- **v Show Settings window v**
function ShowCurrentSettings()
	import "HabnaPlugins.HugeBag.contextMenu"; -- LUA contextual menu file
	contextMenu();
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.ShellCmd"; -- LUA frmShellCmd file
	frmShellCmd();
end
-- **^
-- **v Toggle Slots Info to show free or used slots v**
function ToggleFreeUsed()
	ToggleUsed = ( not ToggleUsed );
	SaveSettings();
	frmMain:PrintTitle();
	--[[
	if ( ToggleUsed ) then
		write( "HugeBag: Now showing used slots informations in the title" );
	else
		write( "HugeBag: Now showing free slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Slots Info v**
function ToggleSlotsInfo()
	ShowSlotsInfo = ( not ShowSlotsInfo );
	SaveSettings();
	frmMain:PrintTitle();
	--[[
	if ( ShowSlotsInfo ) then
		write( "HugeBag: Now showing slots informations in the title" );
	else
		write( "HugeBag: Not showing slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Items Orientation v**
function ToggleItemsOrientation()
	HorizontalOrientation = ( not HorizontalOrientation );
	frmMain.itemListBox.OrientationChanged(sender, args);
	frmMain.itemListBoxScrollBar.OrientationChanged(sender, args);
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
-- **v Toggle Items Orientation v**
function ToggleItemsReverseFill()
	ReverseFill = ( not ReverseFill );
	frmMain.itemListBox:SetReverseFill( ReverseFill );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagSize()
	LockSize = ( not LockSize );
	SaveSettings();
	--[[
	if ( LockSize ) then
		write( "HugeBag: My size is now lock." );
	else
		write( "HugeBag: My size is now unlock." );
	end
	]]
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagPosition()
	LockPosition = ( not LockPosition );
	LockLabel.Enable = not LockPosition;
	SaveSettings();
	--[[
	if ( LockPosition ) then
		--write( "HugeBag: My position is now lock." );
	else
		--write( "HugeBag: My position is now unlock." );
	end
	]]
end
-- **^
-- **v Move all buttons to left side of window v**
function ButtonsLeft()
	if not ButtonAtLeft then
		Diff = MidPos - 85;
		LeftPos, MidPos, RightPos = 35, 85, 135;
		SortLeft = SortLeft - Diff;
		SearchLeft = SearchLeft - Diff;
		MergeLeft = MergeLeft - Diff;
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 13;
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( SortLeft,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = true;
		SaveSettings();
	end
end
-- **^
-- **v Move all buttons to right side of window v**
function ButtonsRight()
	if ButtonAtLeft then
		Diff = ( WinWidth - 185 ) - LeftPos;
		LeftPos = ( WinWidth - 185 );
		MidPos = LeftPos + 50;
		RightPos = MidPos + 50;
		SortLeft = SortLeft + Diff;
		SearchLeft = SearchLeft + Diff;
		MergeLeft = MergeLeft + Diff;
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 13;
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( SortLeft,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = false;
		SaveSettings();
	end
end
-- **^
-- **v Move button to left v**
function MoveButtonLeft()
	MoveTo = "left";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButtonRight()
	MoveTo = "right";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButton()
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;
	if ( MoveTo == "left" ) then
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == LeftPos then
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		end
	else
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == RightPos then
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		end
	end
	if ( ButtonAtTop ) then
		TopPos = 22;
	else
		TopPos = frmMain:GetHeight() - 13;
	end
	SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
	SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
	MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
	SaveSettings();
end
-- **^
-- **v Options List v**
function LoadListOptionsName()
	OptionNameList = {};
	OptionNameList[1]= "Show slots info in title: ";
	OptionNameList[2]= "Slots info to show in title: ";
	OptionNameList[3]= "Start visible at startup: ";
	OptionNameList[4]= "Hide HugeBag when 'esc' key is press: ";
	OptionNameList[5]= "Size locker activated: ";
	OptionNameList[6]= "Position locker activated: ";
	OptionNameList[7]= "HugeBag mode: ";
	OptionNameList[8]= "Show HugeBag skin: ";
	OptionNameList[9]= "Orientation of items: ";
	OptionNameList[10]= "Reverse fill the items: ";
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show";
	ShellCommandName[2]= "hide";
	ShellCommandName[3]= "unload";
	ShellCommandName[4]= "reload";
	ShellCommandName[5]= "resetls";
	ShellCommandName[6]= "resetall";
	ShellCommandName[7]= "togglewesc";
	ShellCommandName[8]= "toggleshow";
	ShellCommandName[9]= "togglemode";
	ShellCommandName[10]= "toggleslots";
	ShellCommandName[11]= "toggleused";
	ShellCommandName[12]= "toggleskin";
	ShellCommandName[13]= "orientation";
	ShellCommandName[14]= "reversefill";
	ShellCommandName[15]= "curopt";
	ShellCommandName[16]= "locksize";
	ShellCommandName[17]= "lockpos";
	ShellCommandName[18]= "sort";
	ShellCommandName[19]= "merge";
	ShellCommandName[20]= "about";
	ShellCommandName[21]= "help/?";
	
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag";
	ShellCommandDes[2]= "Hide HugeBag";
	ShellCommandDes[3]= "Unload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[4]= "Reload HugeBag (NOT WORKING, Turbine API Issues)";
	ShellCommandDes[5]= "Reset location and size settings to default";
	ShellCommandDes[6]= "Reset all settings to default";
	ShellCommandDes[7]= "Toggle hide HugeBag event when the 'esc' key is press";
	ShellCommandDes[8]= "Show or hide HugeBag at startup";
	ShellCommandDes[9]= "Toggle between widget and window mode";
	ShellCommandDes[10]= "Show or hide slots information in title";
	ShellCommandDes[11]= "Toggle to show free or used slots info in title";
	ShellCommandDes[12]= "Toggle HugeBag skin on and off";
	ShellCommandDes[13]= "Toggle items oriention";
	ShellCommandDes[14]= "Toggle reverse fill of items";
	ShellCommandDes[15]= "Show HugeBag Options";
	ShellCommandDes[16]= "Lock/unlock HugeBag size";
	ShellCommandDes[17]= "Lock/unlock HugeBag position";
	ShellCommandDes[18]= "Sort HugeBag items (Courtesy of MrJackdaw)";
	ShellCommandDes[19]= "Merge HugeBag items";
	ShellCommandDes[20]= "Show the 'About' window";
	ShellCommandDes[21]= "Show HugeBag shell commands/?";
end

-- Create ten hacky resize cursors
function createCursor( cursorName, xOffset, yOffset )
	cursor = Turbine.UI.Window();
	cursor:SetSize( 24, 24 );
	cursor:SetBackground( "HabnaPlugins/HugeBag/Resources/"..cursorName..".tga" );
	cursor:SetMouseVisible( false );
	cursor:SetZOrder( 10 );
	
	cursor.xOffset = xOffset;
	cursor.yOffset = yOffset;
	
	return cursor;
end

resizeCursor = createCursor( "resize", 12, 12 );
rightclicCursor = createCursor( "right_clic", 12, 12 );
lotroresizeCursor = createCursor( "lotro_resize", 12, 12 );

function ShowLotroResizeCursor()
	if not LockPosition then
		frmMain.cursor = lotroresizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		frmMain.cursor:SetPosition( mouseX - frmMain.cursor.xOffset, mouseY - frmMain.cursor.yOffset);
		frmMain.cursor:SetVisible( true );
	end
end

function ShowResizeCursor()
	if not LockSize then
		frmMain.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		frmMain.cursor:SetPosition( mouseX - frmMain.cursor.xOffset, mouseY - frmMain.cursor.yOffset);
		frmMain.cursor:SetVisible( true );
	end
end

function mergetable(table1,list)
	--Appends tables from list on the end of table1
	for i=1,#list do
		table2=list[i]
		local LenTable1=#table1
		for a =LenTable1+1,#table1+#table2 do
			table1[a]=table2[a-LenTable1]
		end
	end
end

function ChangeColor()
	frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, curSelRed, curSelGreen, curSelBlue ) );
end